Scala Compiler2.13.0 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  package patmat
  Definition Classes
    transform
-  trait MatchApproximation extends TreeAndTypeAnalysis with ScalaLogic with MatchTreeMaking
  Definition Classes
    patmat
-  trait MatchApproximator extends TreeMakers with TreesAndTypesDomain

  Represent a match as a formula in propositional logic that encodes whether the match matches (abstractly: we only consider types)

  Represent a match as a formula in propositional logic that encodes whether the match matches (abstractly: we only consider types)

  Definition Classes
    MatchApproximation
-  class TreeMakersToProps extends AnyRef
  Definition Classes
    MatchApproximator
- TreeMakerToProp
- conservative

o

scala.tools.nsc.transform.patmat.MatchApproximation.MatchApproximator.TreeMakersToProps

# conservative

###

#### object conservative extends TreeMakerToProp

Source
  MatchAnalysis.scala

Linear Supertypes
TreeMakerToProp, (MatchApproximator.TreeMaker) => MatchApproximator.Prop, AnyRef, Any

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. conservative
2. TreeMakerToProp
3. Function1
4. AnyRef
5. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  def andThen[A](g: (MatchApproximator.Prop) => A): (MatchApproximator.TreeMaker) => A
   Definition Classes
     Function1
   Annotations
     @unspecialized()
5.  def apply(tm: MatchApproximator.TreeMaker): MatchApproximator.Prop

   apply itself must render a faithful representation of the TreeMaker

   apply itself must render a faithful representation of the TreeMaker

   Concretely, True must only be used to represent a TreeMaker that is sure to match and that does not do any computation at all e.g., doCSE relies on apply itself being sound in this sense (since it drops TreeMakers that are approximated to True -- scala/bug#6077)

   handleUnknown may be customized by the caller to approximate further

   TODO: don't ignore outer-checks

   Definition Classes
     TreeMakerToProp → Function1
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
8.  def compose[A](g: (A) => MatchApproximator.TreeMaker): (A) => MatchApproximator.Prop
   Definition Classes
     Function1
   Annotations
     @unspecialized()
9.  final def eq(arg0: AnyRef): Boolean
   Definition Classes
     AnyRef
10.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
11.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
12.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
13.  def handleUnknown(tm: MatchApproximator.TreeMaker): False
    Definition Classes
      conservative → TreeMakerToProp
14.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
15.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
16.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
17.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
18.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
19.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
20.  def toString(): String
    Definition Classes
      Function1 → AnyRef → Any
21.  def updateSubstitution(subst: MatchApproximator.Substitution): Unit
    Definition Classes
      TreeMakerToProp
22.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
23.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
24.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Inherited from TreeMakerToProp

### Inherited from (MatchApproximator.TreeMaker) => MatchApproximator.Prop

### Inherited from AnyRef

### Inherited from Any

### Ungrouped